<template>
  <div>
    <v-card>
      <v-card-title>
        <v-btn
          color="primary"
          id="new-student-btn"
          @click="studentCreate = !studentCreate"
          elevation="0"
        >
          Novo
        </v-btn>

        <v-spacer></v-spacer>

        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          class="shrink"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>

      <v-container>
        <v-row>
          <div class="col-12">
            <v-data-table
              :headers="headers"
              :items="students"
              :items-per-page="5"
              :search="search"
              class="elevation-0"
            >
              <template v-slot:[`item.actions`]="{ item }">
                <v-icon
                  color="primary"
                  title="Editar"
                  @click="openUpdate(item.id)"
                >
                  mdi-pencil
                </v-icon>
                <v-icon
                  class="mx-2"
                  title="Apagar"
                  color="red"
                  @click="deleteStudent(item.id)"
                >
                  mdi-delete
                </v-icon>
                <v-icon
                  title="Detalhes"
                  color="info"
                  @click="openDetails(item.id)"
                >
                  mdi-eye
                </v-icon>
              </template>
            </v-data-table>
          </div>
        </v-row>
      </v-container>
    </v-card>

    <v-dialog v-model="studentCreate" max-width="800px">
      <StudentCreate :closeDialog="() => (studentCreate = false)" />
    </v-dialog>

    <v-dialog v-model="studentUpdate" max-width="800px">
      <StudentEdit
        :closeDialog="closeStudentUpdate"
        :studentId="updateStudentId"
      />
    </v-dialog>

    <v-dialog v-model="studentDetails" max-width="800px">
      <StudentDetails
        :closeDialog="closeStudentDetails"
        :studentId="detaislStudentId"
      />
    </v-dialog>
  </div>
</template>

<script>
import StudentCreate from "../components/StudentCreate.vue";
import StudentDetails from "../components/StudentDetails.vue";
import StudentEdit from "../components/StudentEdit.vue";

export default {
  name: "Student-view",

  components: {
    StudentCreate,
    StudentDetails,
    StudentEdit,
  },

  created() {
    if (!this.students.length) this.$store.dispatch("getStudents");
  },

  data: () => ({
    search: "",
    studentCreate: false,
    studentDetails: false,
    studentUpdate: false,
    detaislStudentId: null,
    updateStudentId: null,
    deleteStudentId: null,
    headers: [
      { text: "ID", value: "id" },
      { text: "Nome", value: "name" },
      { text: "Email", value: "email" },
      { text: "Ações", value: "actions", sortable: false },
    ],
  }),

  computed: {
    students() {
      return this.$store.state.student.list;
    },
  },

  methods: {
    editStudent(student) {
      this.updateStudentId = student.id;
      this.studentCreate = true;
    },
    closeStudentCreate() {
      this.studentCreate = false;
    },
    openDetails(id) {
      this.detaislStudentId = id;
      this.studentDetails = true;
    },
    openUpdate(id) {
      this.updateStudentId = id;
      this.studentUpdate = true;
    },
    closeStudentDetails() {
      this.studentDetails = false;
    },
    closeStudentUpdate() {
      this.studentUpdate = false;
    },
    async deleteStudent(id) {
      this.deleteStudentId = id;
      const reuslt = await this.$swal({
        title: "Tem certeza que quer apagar esse aluno?",
        text: "Uma vez que apague não será possivel recuperar",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, apague!",
        cancelButtonText: "Não, cancelar !",
        closeOnConfirm: false,
        closeOnCancel: false,
      });
      if (reuslt.isConfirmed) {
        this.$store.dispatch("deleteStudent", this.deleteStudentId);
        await this.$swal("Apagado com sucesso!", "", "success");
      }
    },
  },
};
</script>
